 function M = gbs_location(M)

s   = sum(M.s==find(M.regimes(2,:)),2) + 2*(1-sum(M.s==find(M.regimes(2,:)),2));

Y = (M.yt(:,1)-M.params.phi*M.yt(:,2)-M.params.adjshape(M.s).*M.z)./(sqrt(1-M.params.adjshape(M.s).^2).*M.params.scale(M.s));
X = 1.00./(sqrt(1-M.params.adjshape(M.s).^2).*M.params.scale(M.s));

terminal = 0;
while terminal == 0
    bet = NaN(2,1);
    for i=1:2
        V = inv( inv(M.prior.location.sig(i)) + X(s==i)'*X(s==i) );
        n = ( inv(M.prior.location.sig(i)) + X(s==i)'*X(s==i) )\( M.prior.location.sig(i)\M.prior.location.mu(i) + X(s==i)'*Y(s==i) );
        %
        bet(i,1) = normrnd(n,sqrt(V));
    end
    if bet(1,1)<bet(2,1)
        terminal=1;
    end
end

M.params.location(M.regimes(2,:)==1) = bet(1,1);
M.params.location(M.regimes(2,:)==0) = bet(2,1);