function M = gbs_scale(M)

s   = sum(M.s==find(M.regimes(3,:)),2) + 2*(1-sum(M.s==find(M.regimes(3,:)),2));
%u   = (M.yt(:,1)-M.params.location(M.s)-M.params.adjshape(M.s).*M.z-M.yt(:,2)*M.params.phi)./(sqrt(1-M.params.adjshape(M.s).^2));
u2 = ( (M.yt(:,1)-M.params.location(M.s)).^2 - 2*(M.yt(:,1)-M.params.location(M.s)).*M.params.adjshape(M.s).*M.z + M.z.^2 )./(2*(1-M.params.adjshape(M.s).^2));
%u2 = ( (M.yt(:,1)-M.params.location(M.s)).^2 - 2*(M.yt(:,1)-M.params.location(M.s)).*M.params.adjshape(M.s).*M.z + M.z.^2 )./(1*(1-M.params.adjshape(M.s).^2));

% figure
% subplot(1,2,1)
% plot(sqrt(u2))
% subplot(1,2,2)
% plot(u)
% std(u)
% size(u2)

terminal = 0;
while terminal == 0
    bet = NaN(2,1);
    for i=1:2
        %b = M.prior.scale.mu(i) + sum(u2(s==i));
        %a = M.prior.scale.sig(i) + sum(s==i);
        s_invgam  = M.prior.scale.mu(i) + sum(u2(s==i));
        nu_invgam = M.prior.scale.sig(i) + sum(s==i);
        %
        bet(i,1)  = gen_ig1_dyn(s_invgam,nu_invgam);
        
        %zdraws = gamrnd(a,1/b);  %Note that in Matlab, it is 1/b, NOT b.
        %bet(i,1) = sqrt(1.0./zdraws);

    end
    if bet(1,1)>bet(2,1)
        terminal=1;
    end
end

M.params.scale(M.regimes(3,:)==1) = bet(1,1);
M.params.scale(M.regimes(3,:)==0) = bet(2,1);
