function M = gbs_z(M)

l = 0.000;
u = Inf;

z = zeros(M.t,1);

for j=1:M.t
    m = M.params.adjshape(M.s(j))*(M.yt(j,1)-M.params.location(M.s(j))-M.params.phi*M.yt(j,2));
    s = M.params.scale(M.s(j))*sqrt(1-M.params.adjshape(M.s(j))^2);
    
    x    = trandn((l-m)/s,(u-m)/s);
    z(j) = m + s*x;
end

M.z = z;