function [DMW,GWp,pvalue]= dmwtest(loss_1,loss_2,p)

% see "Understanding Models' Forecasting Performance"
% by Barbara Rossi and Tatevik Sekhposyan

DeltaL = loss_1-loss_2;

qn = floor(size(DeltaL,1)^(1/4));
sigma = sqrt(nw(DeltaL,qn));

DMW    = sqrt(size(DeltaL,1))*mean(DeltaL)/sigma;
pvalue = 1-cdf('chi2',DMW^2,1);
if (pvalue>p)
    GWp = 0;
else
    GWp = 1;
end