figure;
subplot(2,3,1)
plot(a1gbs(:,1))
hold on
plot(M.Postmode(8)*ones(fss,1),'r')
title('a1(shape)')
subplot(2,3,2)
plot(a2gbs(:,1))
hold on
plot(M.Postmode(9)*ones(fss,1),'r')
title('a2(shape)')
subplot(2,3,3)
plot(b11gbs(:,1))
hold on
plot(M.Postmode(10)*ones(fss,1),'r')
title('b1(shape,gdp)')
subplot(2,3,4)
plot(b12gbs(:,1))
hold on
plot(M.Postmode(11)*ones(fss,1),'r')
title('b1(shape,ciss)')
subplot(2,3,5)
plot(b21gbs(:,1))
hold on
plot(M.Postmode(12)*ones(fss,1),'r')
title('b2(shape,gdp)')
subplot(2,3,6)
plot(b22gbs(:,1))
hold on
plot(M.Postmode(13)*ones(fss,1),'r')
title('b2(shape,ciss)')
sgtitle('shape')

if(idx_fig)
    set(gcf,'PaperUnits','inches');
    set(gcf,'PaperSize',[7 5]);
    set(gcf,'PaperPositionMode','manual');
    set(gcf,'PaperPosition',[0 0 7 5]);
    
    set(gcf,'renderer','painters');
    eval(['print -dpdf ',path_fig,'/shape_',datestr(M.DatRT)]);
end
%
figure;
subplot(2,3,1)
plot(a1gbs(:,2))
hold on
plot(M.Postmode(14)*ones(fss,1),'r')
title('a1(location)')
subplot(2,3,2)
plot(a2gbs(:,2))
hold on
plot(M.Postmode(15)*ones(fss,1),'r')
title('a2(location)')
subplot(2,3,3)
plot(b11gbs(:,2))
hold on
plot(M.Postmode(16)*ones(fss,1),'r')
title('b1(location,gdp)')
subplot(2,3,4)
plot(b12gbs(:,2))
hold on
plot(M.Postmode(17)*ones(fss,1),'r')
title('b1(location,ciss)')
subplot(2,3,5)
plot(b21gbs(:,2))
hold on
plot(M.Postmode(18)*ones(fss,1),'r')
title('b2(location,gdp)')
subplot(2,3,6)
plot(b22gbs(:,2))
hold on
plot(M.Postmode(19)*ones(fss,1),'r')
title('b2(location,ciss)')
sgtitle('location')

if(idx_fig)
    set(gcf,'PaperUnits','inches');
    set(gcf,'PaperSize',[7 5]);
    set(gcf,'PaperPositionMode','manual');
    set(gcf,'PaperPosition',[0 0 7 5]);
    
    set(gcf,'renderer','painters');
    eval(['print -dpdf ',path_fig,'/location_',datestr(M.DatRT)]);
end

%
figure;
subplot(2,3,1)
plot(a1gbs(:,3))
hold on
plot(M.Postmode(20)*ones(fss,1),'r')
title('a1(scale)')
subplot(2,3,2)
plot(a2gbs(:,3))
hold on
plot(M.Postmode(21)*ones(fss,1),'r')
title('a2(scale)')
subplot(2,3,3)
plot(b11gbs(:,3))
hold on
plot(M.Postmode(22)*ones(fss,1),'r')
title('b1(scale,gdp)')
subplot(2,3,4)
plot(b12gbs(:,3))
hold on
plot(M.Postmode(23)*ones(fss,1),'r')
title('b1(scale,ciss)')
subplot(2,3,5)
plot(b21gbs(:,3))
hold on
plot(M.Postmode(24)*ones(fss,1),'r')
title('b2(scale,gdp)')
subplot(2,3,6)
plot(b22gbs(:,3))
hold on
plot(M.Postmode(25)*ones(fss,1),'r')
title('b2(scale,ciss)')
sgtitle('scale')

if(idx_fig)
    set(gcf,'PaperUnits','inches');
    set(gcf,'PaperSize',[7 5]);
    set(gcf,'PaperPositionMode','manual');
    set(gcf,'PaperPosition',[0 0 7 5]);
    
    set(gcf,'renderer','painters');
    eval(['print -dpdf ',path_fig,'/scale_',datestr(M.DatRT)]);
end

%
figure;
subplot(3,3,1)
histogram(phigbs(:,1));
hold on
xline(M.Postmode(7),'r');
title('phi')
subplot(3,3,2)
histogram(invscale2gbs(:,1));
hold on
xline(M.Postmode(3),'r');
title('scale(1)')
subplot(3,3,3)
histogram(invscale2gbs(:,2));
hold on
xline(M.Postmode(4),'r');
title('scale(2)')
subplot(3,3,4)
histogram(shapegbs(:,1));
hold on
xline(M.Postmode(5),'r');
title('shape(1)')
subplot(3,3,5)
histogram(shapegbs(:,5));
hold on
xline(M.Postmode(6),'r');
title('shape(2)')
subplot(3,3,6)
histogram(locationgbs(:,1));
hold on
xline(M.Postmode(1),'r');
title('location(1)')
subplot(3,3,7)
histogram(locationgbs(:,3));
hold on
xline(M.Postmode(2),'r');
title('location(2)')
sgtitle('skn parameters')

if(idx_fig)
    set(gcf,'PaperUnits','inches');
    set(gcf,'PaperSize',[7 5]);
    set(gcf,'PaperPositionMode','manual');
    set(gcf,'PaperPosition',[0 0 7 5]);
    
    set(gcf,'renderer','painters');
    eval(['print -dpdf ',path_fig,'/skn_',datestr(M.DatRT)]);
end

%
figure;
subplot(3,1,1)
plot(M.Dat,Pr_location(:,1))
xlim([M.Dat(1) M.Dat(end)])
ylim([-0.05 1.05])
xlabel('years')
ylabel('prob.')
title('location')
subplot(3,1,2)
plot(M.Dat,Pr_scale(:,1))
xlim([M.Dat(1) M.Dat(end)])
ylim([-0.05 1.05])
xlabel('years')
ylabel('prob.')
title('scale')
subplot(3,1,3)
plot(M.Dat,Pr_shape(:,1))
xlim([M.Dat(1) M.Dat(end)])
ylim([-0.05 1.05])
xlabel('years')
ylabel('prob.')
title('shape')
sgtitle('probability regimes')

if(idx_fig)
set(gcf,'PaperUnits','inches');
set(gcf,'PaperSize',[7 5]);
set(gcf,'PaperPositionMode','manual');
set(gcf,'PaperPosition',[0 0 7 5]);

set(gcf,'renderer','painters');
eval(['print -dpdf ',path_fig,'/fp_',datestr(M.DatRT)]);

close all;
end

