function M = gbs_invscale2(M)

s  = sum(M.s==find(M.regimes(3,:)),2) + 2*(1-sum(M.s==find(M.regimes(3,:)),2));
u2 = ( (M.yt(:,1)-M.params.location(M.s)).^2 - 2*(M.yt(:,1)-M.params.location(M.s)).*M.params.adjshape(M.s).*M.z + M.z.^2 )./(2*(1-M.params.adjshape(M.s).^2));

terminal = 0;
while terminal == 0
    bet = NaN(2,1);
    for i=1:2
        a_gam = M.prior.invscale2.a(i) + sum(s==i); 
        b_gam = M.prior.invscale2.b(i) + sum(u2(s==i));    
        %
        bet(i,1) = gamrnd(a_gam,1/b_gam);  %Note that in Matlab, it is 1/b, NOT b.
    end

    if bet(1,1)<bet(2,1)
        terminal=1;
    end
end

M.params.invscale2(M.regimes(3,:)==1) = bet(1,1);
M.params.invscale2(M.regimes(3,:)==0) = bet(2,1);

M.params.scale = sqrt(1./M.params.invscale2);