function M = gbs_phi(M)

Y = (M.yt(:,1)-M.params.location(M.s)-M.params.adjshape(M.s).*M.z)./(sqrt(1-M.params.adjshape(M.s).^2).*M.params.scale(M.s));
X = M.yt(:,2)./(sqrt(1-M.params.adjshape(M.s).^2).*M.params.scale(M.s));

V = inv( inv(M.prior.phi.sig) + X'*X );
n = ( inv(M.prior.phi.sig) + X'*X )\( M.prior.phi.sig\M.prior.phi.mu + X'*Y );
    
bet = normrnd(n,sqrt(V));

M.params.phi = bet;