function lcond = lik_conditional_st(location, scale, shape, phi, y)

nr=size(shape,1);
lcond=NaN(1,nr);

for j=1:nr   
	lcond(:,j) = log(2) - 0.5*log(2*pi) - log(scale(j)) - ((y(1)-location(j)-phi*y(2) ...
                ).^2)./(2*scale(j).^2) + log(normcdf(shape(j).*(y(1)-location(j)-phi*y(2) ...
                )./scale(j)));
end